#!/usr/bin/env bash

set -Eeuo pipefail

export PGUSER="$POSTGRES_USER"

psql <<- EOSQL
  CREATE DATABASE "${MAIL_MAIL_PG_DBNAME}";
  CREATE DATABASE "${MAIL_SQLGREY_PG_DBNAME}";
  CREATE DATABASE "${MAIL_ROUNDCUBE_PG_DBNAME}";

  REVOKE ALL ON DATABASE "${MAIL_MAIL_PG_DBNAME}" FROM PUBLIC;
  REVOKE ALL ON DATABASE "${MAIL_SQLGREY_PG_DBNAME}" FROM PUBLIC;
  REVOKE ALL ON DATABASE "${MAIL_ROUNDCUBE_PG_DBNAME}" FROM PUBLIC;

  CREATE ROLE "${MAIL_POSTFIX_PG_USER}" WITH LOGIN PASSWORD '${MAIL_POSTFIX_PG_PASS}';
  CREATE ROLE "${MAIL_DOVECOT_PG_USER}" WITH LOGIN PASSWORD '${MAIL_DOVECOT_PG_PASS}';
  CREATE ROLE "${MAIL_SQLGREY_PG_USER}" WITH LOGIN PASSWORD '${MAIL_SQLGREY_PG_PASS}';
  CREATE ROLE "${MAIL_ROUNDCUBE_PG_USER}" WITH LOGIN PASSWORD '${MAIL_ROUNDCUBE_PG_PASS}';

  GRANT CONNECT ON DATABASE "${MAIL_MAIL_PG_DBNAME}" TO "${MAIL_POSTFIX_PG_USER}";
  GRANT CONNECT ON DATABASE "${MAIL_MAIL_PG_DBNAME}" TO "${MAIL_DOVECOT_PG_USER}";
  GRANT CONNECT ON DATABASE "${MAIL_SQLGREY_PG_DBNAME}" TO "${MAIL_SQLGREY_PG_USER}";
  GRANT CONNECT ON DATABASE "${MAIL_ROUNDCUBE_PG_DBNAME}" TO "${MAIL_ROUNDCUBE_PG_USER}";
EOSQL

psql "${MAIL_MAIL_PG_DBNAME}" <<-EOSQL
  CREATE EXTENSION IF NOT EXISTS "uuid-ossp";

  CREATE SCHEMA "mail";
  CREATE SCHEMA "opendkim";
  CREATE SCHEMA "dovecot";
  CREATE SCHEMA "postfix";
  CREATE SCHEMA "quota";

  GRANT USAGE ON SCHEMA "postfix" TO "${MAIL_POSTFIX_PG_USER}";
  GRANT USAGE ON SCHEMA "dovecot" TO "${MAIL_DOVECOT_PG_USER}";

  ALTER DEFAULT PRIVILEGES IN SCHEMA "postfix"
  GRANT SELECT ON TABLES TO "${MAIL_POSTFIX_PG_USER}";

  ALTER DEFAULT PRIVILEGES IN SCHEMA "dovecot"
  GRANT SELECT, INSERT, UPDATE, DELETE ON TABLES TO "${MAIL_DOVECOT_PG_USER}";
EOSQL

psql "${MAIL_SQLGREY_PG_DBNAME}" <<-EOSQL
  GRANT USAGE ON SCHEMA "public" TO "${MAIL_SQLGREY_PG_USER}";

  ALTER DEFAULT PRIVILEGES IN SCHEMA "public"
  GRANT ALL PRIVILEGES ON TABLES TO "${MAIL_SQLGREY_PG_USER}";
EOSQL

psql "${MAIL_ROUNDCUBE_PG_DBNAME}" <<-EOSQL
  GRANT USAGE ON SCHEMA "public" TO "${MAIL_ROUNDCUBE_PG_USER}";

  ALTER DEFAULT PRIVILEGES IN SCHEMA "public"
  GRANT ALL PRIVILEGES ON TABLES TO "${MAIL_ROUNDCUBE_PG_USER}";
EOSQL
